import * as OutlineIcons from '@heroicons/react/24/outline';
import * as SolidIcons from '@heroicons/react/24/solid';
import React from 'react';
export type IconName = keyof typeof SolidIcons | keyof typeof OutlineIcons;
export interface DropdownProps {
    className?: string;
    buttonContent?: string;
    optionTitle?: string;
    loading?: boolean;
    options?: Array<{
        content?: string;
        icon?: IconName;
        iconOutline?: boolean;
        active?: boolean;
        destructive?: boolean;
        onClick?(): void;
    }>;
    origin?: 'left' | 'right' | 'top-left';
    type?: 'default' | 'icon-only' | 'date-picker' | 'ellipsis-icon' | 'soft-small';
    defaultDate?: string;
    max?: string;
    min?: string;
    startDisabled?: string;
    endDisabled?: string;
    disabledDate?: Array<string>;
    onChangeDate?(): void;
    soft?: boolean;
    widthContent?: any;
    isFullContentOption?: boolean;
    disabled?: boolean;
}
export declare function PHXDropdown({ buttonContent, className, defaultDate, disabledDate, endDisabled, loading, max, min, onChangeDate, optionTitle, options, origin, soft, startDisabled, type, widthContent, isFullContentOption, disabled, }: DropdownProps): React.JSX.Element;
