"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var react_1 = require("react");
var getLoginInfo_1 = tslib_1.__importDefault(require("../getLoginInfo"));
var clientQueryV3_1 = tslib_1.__importDefault(require("../clientQueryV3"));
var school_year_v3_1 = require("../../../query/school-year-v3");
function PHXGetActiveYearAndNextYearV3() {
    var schoolInfo = (0, getLoginInfo_1["default"])();
    var _a = (0, react_1.useState)([]), listSchoolYear = _a[0], setListSchoolYear = _a[1];
    var _b = (0, react_1.useState)(), schoolYearData = _b[0], setSchoolYearData = _b[1];
    var currentDate = new Date();
    currentDate.setFullYear(currentDate.getFullYear() + 1);
    var timeYearActive = new Date().toISOString().slice(0, 10);
    var nextYearDate = currentDate.toISOString().slice(0, 10);
    (0, react_1.useEffect)(function () {
        (0, clientQueryV3_1["default"])({
            query: school_year_v3_1.getActiveAndNextSchoolYearV3,
            variables: {
                endAt: timeYearActive,
                startAt: nextYearDate,
                school_id: schoolInfo === null || schoolInfo === void 0 ? void 0 : schoolInfo.school_id
            }
        }).then(function (res) {
            setSchoolYearData(res.data);
        });
    }, []);
    (0, react_1.useEffect)(function () {
        if ((schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) && schoolYearData.school_year.length > 0) {
            // @ts-ignore
            var arraySchoolYear = (schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) || [];
            setListSchoolYear(arraySchoolYear);
        }
        else {
            setListSchoolYear([]);
        }
    }, [schoolYearData]);
    return listSchoolYear;
}
exports["default"] = PHXGetActiveYearAndNextYearV3;
//# sourceMappingURL=getActiveAndNextSchoolYearV3.js.map