"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var client_1 = require("@apollo/client");
var react_1 = require("react");
var getLoginInfo_1 = tslib_1.__importDefault(require("./getLoginInfo"));
var gql_1 = require("../../query/gql");
var clientQueryV2_1 = tslib_1.__importDefault(require("./clientQueryV2"));
function PHXGetActiveYearAndNextYear() {
    var schoolInfo = (0, getLoginInfo_1["default"])();
    var _a = (0, react_1.useState)([]), listSchoolYear = _a[0], setListSchoolYear = _a[1];
    var currentDate = new Date();
    currentDate.setFullYear(currentDate.getFullYear() + 1);
    var timeYearActive = new Date().toISOString().slice(0, 10);
    var nextYearDate = currentDate.toISOString().slice(0, 10);
    var _b = (0, client_1.useLazyQuery)(gql_1.getActiveAndNextSchoolYear, {
        fetchPolicy: 'network-only',
        notifyOnNetworkStatusChange: true
    }), getActiveSchoolYearInfo = _b[0], schoolYearData = _b[1].data;
    (0, react_1.useEffect)(function () {
        (0, clientQueryV2_1["default"])(getActiveSchoolYearInfo, {
            variables: {
                endAt: timeYearActive,
                startAt: nextYearDate,
                school_id: schoolInfo === null || schoolInfo === void 0 ? void 0 : schoolInfo.school_id
            }
        });
    }, []);
    (0, react_1.useEffect)(function () {
        if ((schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) && schoolYearData.school_year.length > 0) {
            // @ts-ignore
            var arraySchoolYear = (schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) || [];
            setListSchoolYear(arraySchoolYear);
        }
        else {
            setListSchoolYear([]);
        }
    }, [schoolYearData]);
    return listSchoolYear;
}
exports["default"] = PHXGetActiveYearAndNextYear;
//# sourceMappingURL=getActiveAndNextSchoolYear.js.map