"use strict";
exports.__esModule = true;
exports.useDisableClick = void 0;
var react_1 = require("react");
function useDisableClick(disabled, handleClick) {
    var handleClickWrapper = (0, react_1.useCallback)(function (event) {
        if (disabled) {
            event.preventDefault();
            event.stopPropagation();
        }
    }, [disabled]);
    if (!disabled) {
        return handleClick;
    }
    return handleClickWrapper;
}
exports.useDisableClick = useDisableClick;
//# sourceMappingURL=use-disable-interaction.js.map