import { useState, useEffect } from 'react';
import PHXFuncGetLoggedInfo from '../getLoginInfo';
import PHXClientQueryV3 from '../clientQueryV3';
import { getActiveAndNextSchoolYearV3 } from '../../../query/school-year-v3';
function PHXGetActiveYearAndNextYearV3() {
    var schoolInfo = PHXFuncGetLoggedInfo();
    var _a = useState([]), listSchoolYear = _a[0], setListSchoolYear = _a[1];
    var _b = useState(), schoolYearData = _b[0], setSchoolYearData = _b[1];
    var currentDate = new Date();
    currentDate.setFullYear(currentDate.getFullYear() + 1);
    var timeYearActive = new Date().toISOString().slice(0, 10);
    var nextYearDate = currentDate.toISOString().slice(0, 10);
    useEffect(function () {
        PHXClientQueryV3({
            query: getActiveAndNextSchoolYearV3,
            variables: {
                endAt: timeYearActive,
                startAt: nextYearDate,
                school_id: schoolInfo === null || schoolInfo === void 0 ? void 0 : schoolInfo.school_id
            }
        }).then(function (res) {
            setSchoolYearData(res.data);
        });
    }, []);
    useEffect(function () {
        if ((schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) && schoolYearData.school_year.length > 0) {
            // @ts-ignore
            var arraySchoolYear = (schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) || [];
            setListSchoolYear(arraySchoolYear);
        }
        else {
            setListSchoolYear([]);
        }
    }, [schoolYearData]);
    return listSchoolYear;
}
export default PHXGetActiveYearAndNextYearV3;
//# sourceMappingURL=getActiveAndNextSchoolYearV3.js.map