import Cookies from 'js-cookie';
import { AUTH_TOKEN } from '../../utils/constants';
import { HttpLink } from '@apollo/client';
import { getEnv } from '../../read-env-config';
export default function PHXGetHttpLinkConfig() {
    var env = getEnv('NEXT_PUBLIC_ENV', process.env.NEXT_PUBLIC_ENV);
    var publicAPI = getEnv('NEXT_PUBLIC_API', process.env.NEXT_PUBLIC_API);
    var uri = "".concat(publicAPI, "/graphql/rd/v1/graphql");
    if (env === 'local') {
        uri = publicAPI;
    }
    var authTokenInfo = Cookies.get(AUTH_TOKEN) && JSON.parse(Cookies.get(AUTH_TOKEN));
    var httpLink = new HttpLink({
        uri: uri
    });
    console.log('httpLink in table', httpLink);
    if (Cookies.get(AUTH_TOKEN)) {
        httpLink = new HttpLink({
            uri: uri,
            headers: {
                Authorization: 'Bearer' + ' ' + authTokenInfo.token,
                'authorization-id': authTokenInfo.userId
            }
        });
    }
    return httpLink;
}
//# sourceMappingURL=getHttpLinkConfig.js.map