import React from 'react';
import { BaseButton, ComplexAction } from '../types';
import * as SolidIcons from '@heroicons/react/24/solid';
import * as OutlineIcons from '@heroicons/react/24/outline';
export type IconName = keyof typeof SolidIcons | keyof typeof OutlineIcons;
export interface ButtonProps extends BaseButton {
    primary?: boolean;
    secondary?: boolean;
    danger?: boolean;
    danger2?: boolean;
    soft?: boolean;
    plain?: boolean;
    tertiary?: boolean;
    plainCritical?: boolean;
    primaryCritical?: boolean;
    split?: boolean;
    options?: Array<{
        name: string;
        onClick(): any;
    }>;
    deleted?: boolean;
    deletedButton?: boolean;
    rounded?: boolean;
    size?: 'micro' | 'small' | 'medium' | 'large' | 'extra-large';
    children?: string | string[];
    icon?: IconName;
    iconClassName?: string;
    iconOutline?: boolean;
    iconPosition?: 'before' | 'after';
}
export interface ResourceListProps {
    className?: string;
    list?: Array<{
        id?: number;
        name?: string;
        location?: string;
        avatar?: string;
    }>;
    readonly?: boolean;
    button?: ButtonProps;
    bulkActions?: boolean;
    isOptionList?: boolean;
    defaultOptionActive?: any;
    isEmptyData?: any;
    bulkActionsContent?: string;
    heightList?: number;
    actionSelectAll?: boolean;
    searchResult?: boolean;
    shortcutAction?(item: any): Array<{
        content?: string;
        icon?: IconName;
        iconOutline?: boolean;
        active?: boolean;
        destructive?: boolean;
        onClick?(): void;
    }>;
    sortOptions?: Array<{
        content?: string;
        icon?: IconName;
        iconOutline?: boolean;
        active?: boolean;
        destructive?: boolean;
        onClick?(): void;
    }>;
    sortContent?: string;
    onClickItem?(item: any): void;
    onBulkActions?(data: any): void;
    title?: string;
    textAction?: ComplexAction;
    isBadge?: boolean;
    useListWithCard?: boolean;
    onClickRemoveItem?(item: any): void;
}
export declare function PHXResourceList({ className, list, bulkActions, bulkActionsContent, actionSelectAll, readonly, searchResult, isOptionList, defaultOptionActive, isEmptyData, heightList, shortcutAction, sortOptions, button, sortContent, onClickItem, onBulkActions, textAction, title, isBadge, useListWithCard, onClickRemoveItem, }: ResourceListProps): React.JSX.Element;
