import { faAngleRight, faAngleLeft } from '@fortawesome/free-solid-svg-icons';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import React from 'react';
function classNames() {
    var classes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        classes[_i] = arguments[_i];
    }
    return classes.filter(Boolean).join(' ');
}
var Pagination = function (_a) {
    var currentPage = _a.currentPage, handleChangePage = _a.handleChangePage, totalPages = _a.totalPages, pagination = _a.pagination, rowQuantity = _a.rowQuantity, count = _a.count;
    var pages = [];
    for (var i = 1; i <= totalPages; i++) {
        pages.push(i);
    }
    var handleClickPage = function (page) {
        handleChangePage(page);
    };
    var disableNextPage = currentPage === totalPages;
    var disablePrevPage = currentPage === 1;
    var PreviousPage = function () { return (React.createElement("a", { "aria-hidden": true, className: classNames('relative inline-flex bg-[#ebebeb] rounded-tl-lg pb-1 pt-0.5 rounded-bl-lg items-center px-3 text-gray-900 focus:z-20 focus:outline-offset-0 min-h-[1.75rem]', !disablePrevPage ? 'hover:bg-[#d4d4d4]' : '', !disablePrevPage
            ? 'active:bg-[#ccc] active:shadow-[0rem_0.125rem_0.1rem_0rem_#0004_inset] active:pt-[0.2rem] active:pb-[0.2rem]'
            : '', !disablePrevPage ? 'cursor-pointer' : ''), onClick: function () { return handleClickPage(currentPage - 1); } },
        React.createElement("p", null,
            React.createElement("span", { className: 'sr-only' }, "Previous"),
            React.createElement(FontAwesomeIcon, { className: classNames('w-2.5 h-3', disablePrevPage ? 'text-gray-300' : 'text-gray-900'), icon: faAngleLeft })))); };
    var NextPage = function () { return (React.createElement("a", { "aria-hidden": true, className: classNames('relative inline-flex rounded-tr-lg bg-[#ebebeb] pb-1 pt-0.5 rounded-br-lg items-center rounded-r-md px-3 text-gray-900 focus:z-20 focus:outline-offset-0 min-h-[1.75rem]', !disableNextPage ? 'hover:bg-[#d4d4d4]' : '', !disableNextPage
            ? 'active:bg-[#ccc] active:shadow-[0rem_0.125rem_0.1rem_0rem_#0004_inset] active:pt-[0.01rem] active:pb-[0.03rem]'
            : '', !disableNextPage ? 'cursor-pointer' : ''), onClick: function () { return handleClickPage(currentPage + 1); } },
        React.createElement("p", null,
            React.createElement("span", { className: 'sr-only' }, "Next"),
            React.createElement(FontAwesomeIcon, { className: classNames('w-2.5 h-3', disableNextPage ? 'text-gray-300' : 'text-gray-900'), icon: faAngleRight })))); };
    var startIndex = pagination * rowQuantity + 1;
    var endIndex = pagination * rowQuantity + rowQuantity;
    return (React.createElement("div", { className: 'flex items-center gap-x-3' },
        React.createElement("p", { className: 'hidden text-xs sm:block' },
            "Hi\u1EC3n th\u1ECB ",
            startIndex,
            " - ",
            endIndex >= count ? count : endIndex,
            " tr\u00EAn ",
            count,
            " b\u1EA3n ghi"),
        React.createElement("div", { className: 'isolate inline-flex -space-x-px rounded-md bg-white shadow-sm' },
            React.createElement("div", { className: 'mr-1' },
                React.createElement(PreviousPage, null)),
            React.createElement(NextPage, null))));
};
export default Pagination;
//# sourceMappingURL=Pagination.js.map