import { useCallback } from 'react';
export function useDisableClick(disabled, handleClick) {
    var handleClickWrapper = useCallback(function (event) {
        if (disabled) {
            event.preventDefault();
            event.stopPropagation();
        }
    }, [disabled]);
    if (!disabled) {
        return handleClick;
    }
    return handleClickWrapper;
}
//# sourceMappingURL=use-disable-interaction.js.map