"use strict";
exports.__esModule = true;
exports.queryProfile = exports.querySearchGlobal = exports.getTuitionDebtRecordByUserCode = exports.getActiveAndNextSchoolYear = exports.querySchoolYearHocvu = exports.querySchoolYear = exports.GET_PERMISSION_DETAIL_USER = exports.getCampaignName = exports.GET_SCHOOL = void 0;
var tslib_1 = require("tslib");
var client_1 = require("@apollo/client");
var constants_1 = require("../utils/constants");
exports.GET_SCHOOL = (0, client_1.gql)(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  query GetSchool($group_id: Int, $school_name_id: Int, $user_id: Int) {\n    school_name(where: { group_id: { _eq: $group_id }, deleted_at: { _is_null: true }, id: { _eq: $school_name_id } }) {\n      schools(where: { deleted_at: { _is_null: true } }) {\n        id\n        name\n      }\n    }\n    users(where: { id: { _eq: $user_id } }) {\n      id\n      full_name\n      email\n      avatar\n    }\n    setting_site(where: { deleted_at: { _is_null: true }, key_setting: { _eq: \"", "\" } }) {\n      value_setting\n      key_setting\n    }\n  }\n"], ["\n  query GetSchool($group_id: Int, $school_name_id: Int, $user_id: Int) {\n    school_name(where: { group_id: { _eq: $group_id }, deleted_at: { _is_null: true }, id: { _eq: $school_name_id } }) {\n      schools(where: { deleted_at: { _is_null: true } }) {\n        id\n        name\n      }\n    }\n    users(where: { id: { _eq: $user_id } }) {\n      id\n      full_name\n      email\n      avatar\n    }\n    setting_site(where: { deleted_at: { _is_null: true }, key_setting: { _eq: \"", "\" } }) {\n      value_setting\n      key_setting\n    }\n  }\n"])), constants_1.KEY_QUERY_SETTING);
exports.getCampaignName = (0, client_1.gql)(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  query MyQuery($id: Int!) {\n    admissions_campaigns_by_pk(id: $id) {\n      id\n      campaign_name\n    }\n  }\n"], ["\n  query MyQuery($id: Int!) {\n    admissions_campaigns_by_pk(id: $id) {\n      id\n      campaign_name\n    }\n  }\n"])));
exports.GET_PERMISSION_DETAIL_USER = (0, client_1.gql)(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  query GetUserPermission($id: Int, $school_id: Int) {\n    permission_user(\n      where: {\n        deleted_at: { _is_null: true }\n        is_active: { _eq: true }\n        school_id: { _eq: $school_id }\n        user_id: { _eq: $id }\n        permission: { deleted_at: { _is_null: true } }\n      }\n    ) {\n      permission {\n        code\n        is_action\n      }\n    }\n    permission_role(\n      where: {\n        deleted_at: { _is_null: true }\n        is_active: { _eq: true }\n        role: {\n          school_id: { _eq: $school_id }\n          deleted_at: { _is_null: true }\n          user_roles: { deleted_at: { _is_null: true }, is_active: { _eq: true }, user_id: { _eq: $id } }\n        }\n      }\n    ) {\n      permission {\n        code\n        is_action\n      }\n      id\n    }\n  }\n"], ["\n  query GetUserPermission($id: Int, $school_id: Int) {\n    permission_user(\n      where: {\n        deleted_at: { _is_null: true }\n        is_active: { _eq: true }\n        school_id: { _eq: $school_id }\n        user_id: { _eq: $id }\n        permission: { deleted_at: { _is_null: true } }\n      }\n    ) {\n      permission {\n        code\n        is_action\n      }\n    }\n    permission_role(\n      where: {\n        deleted_at: { _is_null: true }\n        is_active: { _eq: true }\n        role: {\n          school_id: { _eq: $school_id }\n          deleted_at: { _is_null: true }\n          user_roles: { deleted_at: { _is_null: true }, is_active: { _eq: true }, user_id: { _eq: $id } }\n        }\n      }\n    ) {\n      permission {\n        code\n        is_action\n      }\n      id\n    }\n  }\n"])));
exports.querySchoolYear = (0, client_1.gql)(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n  query MyQuery($school_id: Int!, $gte: timestamptz!, $lte: timestamptz!) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        school_course: { school_id: { _eq: $school_id } }\n        end_at: { _gte: $gte }\n        start_at: { _lte: $lte }\n      }\n    ) {\n      id\n      name\n      code\n      start_at\n      end_at\n      school_terms(where: { deleted_at: { _is_null: true } }) {\n        id\n        code\n        name\n        coefficient\n        start_at\n        end_at\n      }\n      current_term: school_terms(\n        where: { deleted_at: { _is_null: true }, end_at: { _gte: $gte }, start_at: { _lte: $lte } }\n      ) {\n        id\n        code\n        name\n        coefficient\n        start_at\n        end_at\n      }\n    }\n  }\n"], ["\n  query MyQuery($school_id: Int!, $gte: timestamptz!, $lte: timestamptz!) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        school_course: { school_id: { _eq: $school_id } }\n        end_at: { _gte: $gte }\n        start_at: { _lte: $lte }\n      }\n    ) {\n      id\n      name\n      code\n      start_at\n      end_at\n      school_terms(where: { deleted_at: { _is_null: true } }) {\n        id\n        code\n        name\n        coefficient\n        start_at\n        end_at\n      }\n      current_term: school_terms(\n        where: { deleted_at: { _is_null: true }, end_at: { _gte: $gte }, start_at: { _lte: $lte } }\n      ) {\n        id\n        code\n        name\n        coefficient\n        start_at\n        end_at\n      }\n    }\n  }\n"])));
exports.querySchoolYearHocvu = (0, client_1.gql)(templateObject_5 || (templateObject_5 = tslib_1.__makeTemplateObject(["\n  query MyQuery($school_id: Int!, $gte: timestamptz!, $lte: timestamptz!) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        school_course: { school_id: { _eq: $school_id } }\n        end_at: { _gte: $gte }\n        start_at: { _lte: $lte }\n      }\n    ) {\n      id\n      name\n      code\n      start_at\n      end_at\n      school_terms(where: { deleted_at: { _is_null: true } }) {\n        id\n        code\n        name\n        coefficient\n        hoc_vu_start_at\n        hoc_vu_end_at\n      }\n      current_term: school_terms(\n        where: { deleted_at: { _is_null: true }, hoc_vu_end_at: { _gte: $gte }, hoc_vu_start_at: { _lte: $lte } }\n      ) {\n        id\n        code\n        name\n        coefficient\n        hoc_vu_start_at\n        hoc_vu_end_at\n      }\n    }\n  }\n"], ["\n  query MyQuery($school_id: Int!, $gte: timestamptz!, $lte: timestamptz!) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        school_course: { school_id: { _eq: $school_id } }\n        end_at: { _gte: $gte }\n        start_at: { _lte: $lte }\n      }\n    ) {\n      id\n      name\n      code\n      start_at\n      end_at\n      school_terms(where: { deleted_at: { _is_null: true } }) {\n        id\n        code\n        name\n        coefficient\n        hoc_vu_start_at\n        hoc_vu_end_at\n      }\n      current_term: school_terms(\n        where: { deleted_at: { _is_null: true }, hoc_vu_end_at: { _gte: $gte }, hoc_vu_start_at: { _lte: $lte } }\n      ) {\n        id\n        code\n        name\n        coefficient\n        hoc_vu_start_at\n        hoc_vu_end_at\n      }\n    }\n  }\n"])));
exports.getActiveAndNextSchoolYear = (0, client_1.gql)(templateObject_6 || (templateObject_6 = tslib_1.__makeTemplateObject(["\n  query GetActiveAndNextSchoolYear($startAt: timestamptz, $endAt: timestamptz, $school_id: Int) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        start_at: { _lte: $startAt }\n        end_at: { _gte: $endAt }\n        school_course: { school_id: { _eq: $school_id } }\n      }\n      order_by: { id: asc }\n    ) {\n      code\n      end_at\n      id\n      name\n      start_at\n      school_terms(where: { deleted_at: { _is_null: true } }, order_by: { id: asc }) {\n        name\n        code\n        id\n      }\n      school_course {\n        course_name\n        id\n        code\n      }\n    }\n  }\n"], ["\n  query GetActiveAndNextSchoolYear($startAt: timestamptz, $endAt: timestamptz, $school_id: Int) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        start_at: { _lte: $startAt }\n        end_at: { _gte: $endAt }\n        school_course: { school_id: { _eq: $school_id } }\n      }\n      order_by: { id: asc }\n    ) {\n      code\n      end_at\n      id\n      name\n      start_at\n      school_terms(where: { deleted_at: { _is_null: true } }, order_by: { id: asc }) {\n        name\n        code\n        id\n      }\n      school_course {\n        course_name\n        id\n        code\n      }\n    }\n  }\n"])));
exports.getTuitionDebtRecordByUserCode = "\n  query GetTuitionDebtRecordByUserCode($user_code: String, $school_year_id: Int, $school_id: Int) {\n    tuition_fee_debt_record(\n      order_by: { school_term_id: asc }\n      where: {\n        deleted_at: { _is_null: true }\n        school_id: { _eq: $school_id }\n        user_code: { _eq: $user_code }\n        school_term: { school_year_id: { _eq: $school_year_id } }\n      }\n    ) {\n      total_promotion_service\n      total_payment\n      total_promotion_tuition_policy\n      total_promotion_tuition_scholar_ship\n      total_promotion_tuition_seniority\n      total_promotion_early\n      total_promotion_admission\n      total_required_service\n      total_not_required_service\n      total_tuition\n      last_period_debt_balance\n      last_period_credit_balance\n      status\n      last_credit_balance\n      last_debt_balance\n      total_refund\n      total_adjustment_refund\n      total_adjustment_additional\n      id\n      status\n      school_term {\n        school_year {\n          name\n          code\n        }\n        name\n        code\n        coefficient\n        id\n      }\n      profile_student {\n        tuition_notice_delivered_emails(order_by: { created_at: desc }) {\n          link_pdf_cdn\n          tuition_notice_campaign {\n            school_term_id\n          }\n        }\n      }\n      user_code\n    }\n    tuition_fee_debt_record_by_month(\n      order_by: { month_id: asc }\n      where: {\n        deleted_at: { _is_null: true }\n        school_id: { _eq: $school_id }\n        user_code: { _eq: $user_code }\n        school_month: { school_term: { school_year_id: { _eq: $school_year_id } } }\n      }\n    ) {\n      total_promotion_service\n      total_payment\n      total_promotion_tuition_policy\n      total_promotion_tuition_scholar_ship\n      total_promotion_tuition_seniority\n      total_promotion_early\n      total_promotion_admission\n      total_required_service\n      total_not_required_service\n      total_tuition\n      last_period_debt_balance\n      last_period_credit_balance\n      status\n      last_credit_balance\n      last_debt_balance\n      total_refund\n      total_adjustment_refund\n      total_adjustment_additional\n      id\n      status\n      school_month {\n        name\n      }\n      user_code\n    }\n  }\n";
exports.querySearchGlobal = (0, client_1.gql)(templateObject_7 || (templateObject_7 = tslib_1.__makeTemplateObject(["\n  query tim_kiem($school_id: Int, $searchValue: String) {\n    profile_student(\n      where: {\n        _or: [\n          { user_code: { _eq: $searchValue } }\n          { user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true }, full_name: { _eq: $searchValue } } }\n        ]\n      }\n    ) {\n      user_code\n      user {\n        id\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        classroom_students {\n          classroom {\n            name\n          }\n        }\n        id\n        full_name\n      }\n    }\n\n    profile_parent(\n      where: {\n        _or: [\n          { user: { email: { _eq: $searchValue } } }\n          { user: { full_name: { _eq: $searchValue } } }\n          { user: { phone_number: { _eq: $searchValue } } }\n        ]\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      user {\n        id\n        full_name\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        relationship_users(\n          where: {\n            deleted_at: { _is_null: true }\n            user: { deleted_at: { _is_null: true } }\n            userByStudentId: { deleted_at: { _is_null: true } }\n          }\n        ) {\n          userByStudentId {\n            full_name\n          }\n        }\n      }\n    }\n\n    profile_teacher(\n      where: {\n        _or: [\n          { user_code: { _eq: $searchValue } }\n          { user: { email: { _eq: $searchValue } } }\n          { user: { full_name: { _eq: $searchValue } } }\n          { user: { phone_number: { _eq: $searchValue } } }\n        ]\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      user {\n        id\n        full_name\n        email\n        phone_number\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        relationship_users(\n          where: {\n            deleted_at: { _is_null: true }\n            user: { deleted_at: { _is_null: true } }\n            userByStudentId: { deleted_at: { _is_null: true } }\n          }\n        ) {\n          userByStudentId {\n            full_name\n          }\n        }\n      }\n    }\n  }\n"], ["\n  query tim_kiem($school_id: Int, $searchValue: String) {\n    profile_student(\n      where: {\n        _or: [\n          { user_code: { _eq: $searchValue } }\n          { user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true }, full_name: { _eq: $searchValue } } }\n        ]\n      }\n    ) {\n      user_code\n      user {\n        id\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        classroom_students {\n          classroom {\n            name\n          }\n        }\n        id\n        full_name\n      }\n    }\n\n    profile_parent(\n      where: {\n        _or: [\n          { user: { email: { _eq: $searchValue } } }\n          { user: { full_name: { _eq: $searchValue } } }\n          { user: { phone_number: { _eq: $searchValue } } }\n        ]\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      user {\n        id\n        full_name\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        relationship_users(\n          where: {\n            deleted_at: { _is_null: true }\n            user: { deleted_at: { _is_null: true } }\n            userByStudentId: { deleted_at: { _is_null: true } }\n          }\n        ) {\n          userByStudentId {\n            full_name\n          }\n        }\n      }\n    }\n\n    profile_teacher(\n      where: {\n        _or: [\n          { user_code: { _eq: $searchValue } }\n          { user: { email: { _eq: $searchValue } } }\n          { user: { full_name: { _eq: $searchValue } } }\n          { user: { phone_number: { _eq: $searchValue } } }\n        ]\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      user {\n        id\n        full_name\n        email\n        phone_number\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        relationship_users(\n          where: {\n            deleted_at: { _is_null: true }\n            user: { deleted_at: { _is_null: true } }\n            userByStudentId: { deleted_at: { _is_null: true } }\n          }\n        ) {\n          userByStudentId {\n            full_name\n          }\n        }\n      }\n    }\n  }\n"])));
exports.queryProfile = (0, client_1.gql)(templateObject_8 || (templateObject_8 = tslib_1.__makeTemplateObject(["\n  query ho_so_ca_nhan($email: String!) {\n    profile_staff(\n      where: { deleted_at: { _is_null: true }, user: { email: { _eq: $email }, deleted_at: { _is_null: true } } }\n    ) {\n      is_quit_job\n    }\n    profile_teacher(\n      where: { deleted_at: { _is_null: true }, user: { email: { _eq: $email }, deleted_at: { _is_null: true } } }\n    ) {\n      is_quit_job\n    }\n  }\n"], ["\n  query ho_so_ca_nhan($email: String!) {\n    profile_staff(\n      where: { deleted_at: { _is_null: true }, user: { email: { _eq: $email }, deleted_at: { _is_null: true } } }\n    ) {\n      is_quit_job\n    }\n    profile_teacher(\n      where: { deleted_at: { _is_null: true }, user: { email: { _eq: $email }, deleted_at: { _is_null: true } } }\n    ) {\n      is_quit_job\n    }\n  }\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
//# sourceMappingURL=gql.js.map