export declare const getUserInfo = "\n  query MyQuery($userId: Int) {\n    users(where: { id: { _eq: $userId } }) {\n      id\n      email\n      phone_number\n      full_name\n      school_id\n      school {\n        educational_levels(where: { deleted_at: { _is_null: true } }) {\n          code\n        }\n        school_name_id\n        email\n        id\n        phone\n        name\n        school_name {\n          name\n          group_id\n        }\n      }\n      user_roles(where: { is_active: { _eq: true }, deleted_at: { _is_null: true } }) {\n        role_id\n        role {\n          name\n          role_code\n        }\n      }\n    }\n  }\n";
export declare const getTuitionDebtRecordByUserCodeV3 = "\n  query GetTuitionDebtRecordByUserCode($user_code: String, $school_year_id: Int, $school_id: Int) {\n    tuition_fee_debt_record(\n      order_by: { school_term_id: asc }\n      where: {\n        deleted_at: { _is_null: true }\n        school_id: { _eq: $school_id }\n        user_code: { _eq: $user_code }\n        school_term: { school_year_id: { _eq: $school_year_id } }\n      }\n    ) {\n      total_promotion_service\n      total_payment\n      total_promotion_tuition_policy\n      total_promotion_tuition_scholar_ship\n      total_promotion_tuition_seniority\n      total_promotion_early\n      total_promotion_admission\n      total_required_service\n      total_not_required_service\n      total_tuition\n      last_period_debt_balance\n      last_period_credit_balance\n      status\n      last_credit_balance\n      last_debt_balance\n      total_refund\n      total_adjustment_refund\n      total_adjustment_additional\n      id\n      is_locked\n      status\n      school_term {\n        school_year {\n          name\n          code\n        }\n        name\n        code\n        coefficient\n        id\n      }\n      profile_student {\n        tuition_notice_delivered_emails(order_by: { created_at: desc }) {\n          link_pdf_cdn\n          tuition_notice_campaign {\n            school_term_id\n          }\n        }\n      }\n      user_code\n    }\n    tuition_fee_debt_record_by_month(\n      order_by: { month_id: asc }\n      where: {\n        deleted_at: { _is_null: true }\n        school_id: { _eq: $school_id }\n        user_code: { _eq: $user_code }\n        school_month: { school_term: { school_year_id: { _eq: $school_year_id } } }\n      }\n    ) {\n      total_promotion_service\n      total_payment\n      total_promotion_tuition_policy\n      total_promotion_tuition_scholar_ship\n      total_promotion_tuition_seniority\n      total_promotion_early\n      total_promotion_admission\n      total_required_service\n      total_not_required_service\n      total_tuition\n      last_period_debt_balance\n      last_period_credit_balance\n      status\n      last_credit_balance\n      last_debt_balance\n      total_refund\n      total_adjustment_refund\n      total_adjustment_additional\n      id\n      is_locked\n      status\n      school_month {\n        name\n      }\n      user_code\n    }\n  }\n";
export declare const querySearchGlobalV3 = "\n  query QuerySearchGlobal($school_id: Int, $searchValue: String) {\n    profile_student(\n      where: {\n        _or: [\n          { user_code: { _eq: $searchValue } }\n          { user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true }, full_name: { _eq: $searchValue } } }\n        ]\n      }\n    ) {\n      user_code\n      user {\n        id\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        classroom_students {\n          classroom {\n            name\n          }\n        }\n        id\n        full_name\n      }\n    }\n\n    profile_parent(\n      where: {\n        _or: [\n          { user: { email: { _eq: $searchValue } } }\n          { user: { full_name: { _eq: $searchValue } } }\n          { user: { phone_number: { _eq: $searchValue } } }\n        ]\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      user {\n        id\n        full_name\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        relationship_users(\n          where: {\n            deleted_at: { _is_null: true }\n            user: { deleted_at: { _is_null: true } }\n            userByStudentId: { deleted_at: { _is_null: true } }\n          }\n        ) {\n          userByStudentId {\n            full_name\n          }\n        }\n      }\n    }\n\n    profile_teacher(\n      where: {\n        _or: [\n          { user_code: { _eq: $searchValue } }\n          { user: { email: { _eq: $searchValue } } }\n          { user: { full_name: { _eq: $searchValue } } }\n          { user: { phone_number: { _eq: $searchValue } } }\n        ]\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      user {\n        id\n        full_name\n        email\n        phone_number\n        user_roles(where: { deleted_at: { _is_null: true }, user: { deleted_at: { _is_null: true } } }) {\n          role {\n            name\n            role_code\n          }\n        }\n        relationship_users(\n          where: {\n            deleted_at: { _is_null: true }\n            user: { deleted_at: { _is_null: true } }\n            userByStudentId: { deleted_at: { _is_null: true } }\n          }\n        ) {\n          userByStudentId {\n            full_name\n          }\n        }\n      }\n    }\n  }\n";
export declare const getCampaignNameV3 = "\n  query MyQuery($id: Int!) {\n    admissions_campaigns_by_pk(id: $id) {\n      id\n      campaign_name\n    }\n  }\n";
export declare const GET_PERMISSION_DETAIL_USER_V3 = "\n  query GetUserPermission($id: Int, $school_id: Int) {\n    permission_user(\n      where: {\n        deleted_at: { _is_null: true }\n        is_active: { _eq: true }\n        school_id: { _eq: $school_id }\n        user_id: { _eq: $id }\n        permission: { deleted_at: { _is_null: true } }\n      }\n    ) {\n      permission {\n        code\n        is_action\n      }\n    }\n    permission_role(\n      where: {\n        deleted_at: { _is_null: true }\n        is_active: { _eq: true }\n        role: {\n          school_id: { _eq: $school_id }\n          deleted_at: { _is_null: true }\n          user_roles: { deleted_at: { _is_null: true }, is_active: { _eq: true }, user_id: { _eq: $id } }\n        }\n      }\n    ) {\n      permission {\n        code\n        is_action\n      }\n      id\n    }\n  }\n";
export declare const GET_SCHOOL_V3: string;
export declare const queryGetProfileV3 = "\n  query QueryGetProfile($user_id: Int!, $school_id: Int!) {\n    profile_staff(\n      where: {\n        staff_id: { _eq: $user_id }\n        deleted_at: { _is_null: true }\n        user: { deleted_at: { _is_null: true }, school_id: { _eq: $school_id } }\n      }\n    ) {\n      is_quit_job\n    }\n    profile_teacher(\n      where: {\n        teacher_id: { _eq: $user_id }\n        deleted_at: { _is_null: true }\n        user: { school_id: { _eq: $school_id }, deleted_at: { _is_null: true } }\n      }\n    ) {\n      is_quit_job\n    }\n  }\n";
